/* programa funcion-2d.c  
   Calcula cos(x^2+y^2)*exp(-1.0*(x^2+y^2)/PI^2))
   en una rejilla cuadrada de Grid_size x Grid_size puntos 
   y genera el fichero de datos datos-funcion-2d.dat 
*/

#include <stdio.h>
#include <math.h>

double f(double x1, double x2) {
double f1;
f1 = pow(cos(x1*x1+x2*x2),2)*exp(-1.0*(x1*x1+x2*x2)/(M_PI*M_PI));
return f1;
}



int main()
{
int i,j;
int Grid_size=200;
double x;
double ui, uj;
double xmin;
xmin = M_PI;  // los lados del cuadrado son segmentos [-xmin,xmin]

  FILE * output;
  output = fopen("datos-funcion-2d.dat","w");


for(i=0;i<Grid_size;i++)
	{
	ui = (2.0*xmin)*((double)i-(double)Grid_size/2.0)/(double)Grid_size;	
       	for(j=0;j<Grid_size;j++)
		{
	uj = (2.0*xmin)*((double)j-(double)Grid_size/2.0)/(double)Grid_size;	
                x = f(ui,uj) ;
		fprintf(output,"%.10lf \n",x);
		}
	}
return 0;
}
