/* programa funcion-3d.c  
   Calcula cos(x^2)*cos(y^2)*cos(z^2)*exp(-1.0*(x^2+y^2+z^2)/4*PI^2))
   en un cubo de Grid_size x Grid_size x Grid_size puntos 
   y genera el fichero de datos datos-funcion-3d.dat 
*/

#include <stdio.h>
#include <math.h>

double f(double x1, double x2, double x3) {
double f1;
f1 = pow(cos(x1),2)*pow(cos(x2),2)*pow(cos(x3),2)*exp(-1.0*(x1*x1+x2*x2+x3*x3)/(4.0*M_PI*M_PI));
return f1;
}



int main()
{
int i,j,k;
int Grid_size=150;  // No sobrepasar 150 a no ser que el ordenador sea potente 
double x;
double ui,uj,uk;
double xmin;
xmin = 1.5*M_PI;  // los lados del cubo son segmentos [-xmin,xmin]

  FILE * output;
  output = fopen("datos-funcion-3d.dat","w");


for(i=0;i<Grid_size;i++)
	{
	ui = (2.0*xmin)*((double)i-(double)Grid_size/2.0)/(double)Grid_size;	
       	for(j=0;j<Grid_size;j++)
		{
	uj = (2.0*xmin)*((double)j-(double)Grid_size/2.0)/(double)Grid_size;	
            for(k=0;k<Grid_size;k++) {
	uk = (2.0*xmin)*((double)k-(double)Grid_size/2.0)/(double)Grid_size;	
                x = f(ui,uj,uk) ;
		fprintf(output,"%.10lf \n",x);
                  }	
		}
	}
return 0;
}
